package HTML::Phl::Php;
our $VERSION = 0.00.000;  # Для примера

use strict;
use warnings;

use utf8;  # Модуль в unicode
use Time::HiRes "gettimeofday";  # Модуль для рыботы с microseconds
use Encode qw(from_to encode decode);

# Формирование хэша для импорта
our %phl_import = (
       sh    => {
                 php => \&HTML::Phl::Php::php_to_perl
                },
       param => {
                 php => \&HTML::Phl::Php::php_include
                }
				  );

sub php_to_perl {

   my $main = $_[0];
   my $key  = $_[3];

   # Временное имя файла
   my $file = gettimeofday.".php";  # gettimeofday <= use Time::HiRes

   my $file_url = "$HTML::Phl::phl_path_url[-1]$file";

   my $param;
   if ($key =~ /-(?:sk|socket)/) {
      $param = "php socket";
   } else {
      $param = "php";
   }
   
   my $code;
   if ($main =~ s|IN_PERL\s*\(\s*(.*?)\s*->\s*(.*?)\s*\)\s*;|print <<<FOR_PHL\n<PHL>$1</PHL>\nFOR_PHL;|gs) {
      my $data = $2;
      $code = "$data = include('$file', '$param', '$file_url');\n";
   } else {
      $code = "include('$file', '$param', '$file_url');\n";
   }

   $HTML::Phl::phl_var{$file} = $main;

   return $code;
}

sub php_include {

  my $file_name = $_[0];
  my $param     = $_[1];
  my $file_url = $_[2];
  
  my $content;
  
  if ($HTML::Phl::phl_var{$file_name}) {
     $HTML::Phl::phl_var{$file_name} =~ s/OUT_PERL\s*\(\s*(.*?)\s*->\s*(.*?)\s*\)\s*;/"$2 = '".&refs($1)."';\n"/e;

     unless (-e "$file_name") {  # Некоторая защита от перезаписи существующих файлов
        open (my $php_file, ">$file_name");
           flock($php_file, 2);
           print $php_file "<?php\n".$HTML::Phl::phl_var{$file_name}."?>";
        close $php_file;

        if ($param =~ /Simple/i) {
           eval 'use LWP::Simple'; #############
           $content = get("$file_url");  # get() <= use LWP::Simple;
           die "Can't get $file_url"  unless defined $content;
        } else {
		   $param .= " decode=utf-8"  if ($HTML::Phl::phl{encoding_out} eq "utf8");
           $content = &HTML::Phl::phl_get_socket("$file_url", "", "$param");   # &phl_get_socket использует IO::Socket::INET->new() <= use IO::Socket::INET
        }

        unlink("$file_name");  # удаляем временный файл

     }
  } else {
      $content = &HTML::Phl::phl_get_socket("$file_url", "", "$param");   # &phl_get_socket использует IO::Socket::INET->new() <= use IO::Socket::INET
  }
  
  $content =~ s|^(.*)<PHL>(.*)</PHL>(.*)|$1$3|s;

  my $result = $2;
  
  # Не кодируем, если кодировка результирующего файла совпадает с рабочим php
  if ($HTML::Phl::phl{encoding_out} ne "utf8") {
     from_to($result, "utf8", "$HTML::Phl::phl{encoding_out}");
     from_to($content, "utf8", "$HTML::Phl::phl{encoding_out}");
  }

  print $content;  
  
  return $result;
}

sub refs {
  no strict "refs";

  my $data = $_[0];
  $data =~ s/^\$(.+)/HTML::Phl::$1/;
  
  return ${$data};
}

1;

