package HTML::Phl::Psimple;
our $VERSION = 0.00.001;  # 23.11.2017

use strict;
use warnings;
use utf8;
use Encode;

# Формирование хэша для импорта
our %phl_import = (
       param => {
          Simple => \&HTML::Phl::Psimple::simple,
          sl     => \&HTML::Phl::Psimple::simple,
       },
    );

sub simple {
   my $param     = $_[1];
   my $file_url  = $_[3];   
   my $file_name = $_[4];  # ?
  
   # Применение punycode для использования национальных алфавитов в IDN-доменах
   eval "use URI"; 
  
   $file_url = URI->new("$file_url");
   $file_url->canonical();  # <= use URI
  
   eval 'use LWP::Simple';

   my @result;
   if ($param =~ /\b(?:exist|ex)\b/) {
      my @array = head("$file_url");
      if (@array) {  # head() <= use LWP::Simple
         # OK документ существует и доступен
         @result = (1);  # Возврашаем "1" если файл существует
      } else {
         @result = ();  # Возврашаем пустой массив, если файл не существует
      }
   } elsif ($param =~ /\b(?:head|hd)\b/) {
       @result = head("$file_url");  # head() <= use LWP::Simple
   } else {
      # Возвращаем тело запрашиваемого документа с учетом параметров, указанных в $param
      @result = &get_simple("$file_url", "$param");   # &get_simple использует get() & head() <= use LWP::Simple
   }

   if (wantarray()) {  # Списковый контекст
      return @result;
   } elsif (defined wantarray()) {  # Скалярный контекст
      return undef unless (@result);
      return $result[0];
   } else {  # Неопределенный контекст
      print @result;
   }
}

# Подпрограмма по получению документа (используется модуль 'LWP::Simple')
sub get_simple {

  my $file_url = $_[0];   
  my $param    = $_[1];

  my $content = get("$file_url");  # get() <= use LWP::Simple;

  # Устанавливаем абсолютные ссылки в документе
  $content = &HTML::Phl::phl_abs($content, $file_url)  if ($param !~ /no_abs/);

  # Декодируем загружаемый файл в зависимости от кодировки, указанной в $param и настройках
  if ($param =~ /(?:dc|decode)=*([\w\-]*)/) {
     my $decode = $1;
     if ($decode =~ /utf[-]{0,1}8/i) {
        utf8::decode("$content");
     } else {

        $content = decode("$decode", "$content");

     }
  } else {
     # Определяем кодировку
     my $content_type = (head("$file_url"))[0];  # head() <= use LWP::Simple
     my $charset = $1  if ($content_type =~ m/charset=([\w\-]*)/);

     if ($charset) {
        if ($charset =~ /utf[-]{0,1}8/i) {
           utf8::decode("$content");
        } else {
           utf8::decode("$content");
        }
     } else {
        utf8::decode("$content");
     }
  }

  $content = &HTML::Phl::phl_encode("$HTML::Phl::phl{encoding_out}", "$content");

  return ($content);
}

1;