package HTML::Phl::Utilit;
our $VERSION = 0.00.000;  # Концепт

use strict;
use warnings;

use utf8;  # модуль в unicode
use Time::HiRes "gettimeofday";  # Для работы с microseconds

# Формирование хэша для импорта
our %phl_import = (
       key =>     {
                   analys   => \&HTML::Phl::Utilit::key_blok,
                   as       => \&HTML::Phl::Utilit::key_blok,
                   listing  => \&HTML::Phl::Utilit::key_blok,
                   lt       => \&HTML::Phl::Utilit::key_blok,
                   timer    => \&HTML::Phl::Utilit::key_timer,
                   tm       => \&HTML::Phl::Utilit::key_timer,
                   no_timer => \&HTML::Phl::Utilit::key_timer,
                   nt       => \&HTML::Phl::Utilit::key_timer,
                   import   => \&HTML::Phl::Utilit::print_import,
                   im       => \&HTML::Phl::Utilit::print_import,
                   config   => \&HTML::Phl::Utilit::config,
                   cf       => \&HTML::Phl::Utilit::config,
                  },
       param   => {
                   listing => \&HTML::Phl::Utilit::open_listing,
                   lt      => \&HTML::Phl::Utilit::open_listing,
                  },
       include => {
                   TIMER  => \&HTML::Phl::Utilit::my_timer,
                   CONFIG => \&HTML::Phl::Utilit::config,
                  },
       eval    => {
                   analys  => \&HTML::Phl::Utilit::eval_code,
                   as      => \&HTML::Phl::Utilit::eval_code,
                   listing => \&HTML::Phl::Utilit::eval_code,
                   lt      => \&HTML::Phl::Utilit::eval_code,
                  }
    );

sub key_blok {
   my $code = $_[0];
   my $number_blok = $_[1];  # Номер блока или "line"
   my $key = $_[2];
   
   if ($key =~ /(:?lt|listing)/) {
      $HTML::Phl::phl_var{blok}{$number_blok}{listing} = $code;
      $code = '&phl_code_perl_eval($phl_var{blok}{'."$number_blok".'}{listing}, "listing", "", "");'."\n";
   } elsif ($number_blok eq "line") {
      $HTML::Phl::phl_var{phl} = 'analys';
   } elsif ($number_blok  or  $number_blok == 0) {
      $HTML::Phl::phl_var{blok}{$number_blok}{listing} = $code;
      $code = '&phl_code_perl_eval($phl_var{blok}{'."$number_blok".'}{listing}, "analys", "", "");'."\n";
   } else {
      $HTML::Phl::phl_var{phl} = 'analys';
   }
   return $code;
}

# Выводим на экран код, который должен был выполниться         
sub eval_code {
   my $code = shift;  # код
   my $param = shift;
   my $name = shift; # ?
   my $file_include = shift;

   HTML::Phl::phl_header("yes")  if ($HTML::Phl::phl_var{header} eq "no");

print <<'[END]';
<STYLE TYPE="text/css">
<!--
.t1 {
  background: #FFFFD2;
  FONT-FAMILY: 'Courier New', monospace
}
.t2 {
  background: #DFFFDF;
  FONT-FAMILY: 'Courier New', monospace
}
.t3 {
  background: #E7F7FF;
  FONT-FAMILY: 'Courier New', monospace
}
-->
</STYLE>

[END]
   print "<br>file: <B>'$file_include'</B><br>\n"  if ($file_include  and  $param !~ /no_print_file/);
   print "<div style=\"border:solid 1px; border-color:#000000; background-color:#FAFAFA\" align=left>\n";
   print "<font face=\"Courier New\" size=-1>\n";

   my @split = split(/\n/m, $code);
   print "<table CellSpacing=0>\n";

   my ($n, $html, $phl);
   foreach my $line (@split) {
      ($line, $html, $phl) = &encode_html($line, $html, $phl);
      HTML::Phl::phl_print "<tr VAlign=top><td BgColor=F0F0F0>&nbsp;".++$n."&nbsp;</td><td>".$line."</td></tr>\n";
   }
   print "</table>\n";
   print "</div>\n";
   print "</font>\n";

   $HTML::Phl::phl_var{phl} = ""  if ($HTML::Phl::phl_var{phl} eq 'analys');  # Сбрасываем метку
   
   return 0;
}

sub encode_html {
   my $line = $_[0];
   my $html = $_[1] || '';
   my $phl  = $_[2] || '';

   $line =~ s/</&lt;/g;
   $line =~ s/>/&gt;/g;
   
   my %phl_2;
   $phl_2{lt} = "&lt;%";  
   $phl_2{rt} = "%&gt;";
      
   # Раскрашиваем код PHL, внедренный в HTML
   if ($line  and  $phl ne "yes"  and  $line =~ /\Q$phl_2{lt}$HTML::Phl::phl{sh}\E/  and  $line =~ s/(\Q$phl_2{lt}$HTML::Phl::phl{sh}\E(?:(=|:)([^ ]*)){0,1}(?: +(\-[^ ]*)){0,1}(?: +(.*?) +){0,1} *\Q$phl_2{rt}\E)/<span class=t3>$1<\/span>/g) {

   } elsif ($line  and  $phl ne "yes"  and  $line =~ /\Q$phl_2{lt}\E/  and  $line =~ s/(\Q$phl_2{lt}$HTML::Phl::phl{sh}\E(=|:){0,1}([^ \n]*) *(\-[^ \n]+)* *.*)$/<span class=t3>$1<\/span>/) {
      $phl = 'yes';
      
   } elsif ($line  and  $phl eq "yes"  and  $line =~ /\Q$phl_2{rt}\E/  and  $line =~ s/^(.*?\Q$phl_2{rt}\E)/<span class=t3>$1<\/span>/) {
      $phl = 'no';
      
   } elsif ($line  and  $phl ne "yes"  and  $line =~ /\Q$HTML::Phl::phl{ln}$HTML::Phl::phl{sh}\E/  and  $line =~ s/^(\Q$HTML::Phl::phl{ln}\E([^ \n]*)(=|:){0,1}([^ \n]*) *(\-[^ \n]+)* *(.*))$/<span class=t3>$1<\/span>/) {

   } elsif ($phl eq 'yes') {
      $line = "<span class=t3>$line</span>";
   }

   $line =~ s/   /&nbsp;&nbsp; /g;
   $line =~ s/  /&nbsp; /g;

   # Раскрашиваем код HTML, переведённый в Perl анализатором
   if ($html =~ /^yes/) {
      my $t;
      $t = 't1'  if ($html =~ /1$/);
      $t = 't2'  if ($html =~ /2$/);

      if ($line =~ s|^\[HTML\]$|<span class=$t>\[HTML\]</span>|) {
         $html = 'no';
      } else {
         if ($line eq '') {
            $line = "<span class=$t>&nbsp;</span>";  # ?
         } else {
            $line =~ s|"(.*?)"|<font color=green>"$1"</font>|g;
            $line =~ s|'(.*?)'|<font color=green>"$1"</font>|g;
            $line = "<span class=$t>$line</span>";  # ?
         }
      }
   } elsif ($line =~ s|print &lt;&lt;'\[HTML\]' =~ /\(\.\*\)/;$|<span class=t1>print <<'\[HTML\]' =~ /\(\.\*\)/</span>;|) {
      $html = 'yes_1';
   } elsif ($line =~ s|print &lt;&lt;'\[HTML\]';$|<span class=t1>print <<'\[HTML\]'</span>;|) {
      $html = 'yes_1';
   } elsif ($line =~ s|print &lt;&lt;"\[HTML\]";$|<span class=t2>print <<"\[HTML\]"</span>;|) {
      $html = 'yes_2';
   } elsif ($line =~ s|<span class=t3>#(.*)|<font color=#646464><I><span class=t3>#$1</I></font>|g) {
   } elsif ($html =~ /^yes/  and  $line =~ s|(&lt;!--.*?--&gt;)|<font color=#646464><I>#$1</I></font>|g) {
   } else {
      my $line_main;
      if ($line =~ s|(.*?) #(.*)| <font color=#646464><I>#$2</I></font>|g) {
         $line_main = $1;
      } else {
         $line_main = $line;
         $line = "";
      }
      $line_main =~ s/\b(if|elsif|else|my|our|sub|return|foreach|unless|while|ne|eq|or|and|use)\b/<font color=blue><B>$1<\/B><\/font>/g;
      $line_main =~ s|"(.*?)"|<font color=#710000>"$1"</font>|g;
      $line_main =~ s|'(.*?)'|<font color=#710000>'$1'</font>|g;
      $line = $line_main.$line;
   }

   return ($line, $html, $phl);
}

sub open_listing {

   my $file_include = $_[0];  # or $HTML::Phl::phl_var{blok}{$number_blok}{listing}
   my $param        = $_[1];  # or $key
   my $file_name    = $_[4];
     
   my $code;
   if ($file_include =~ /^(:?http|ftp)/i) {
      $code = &HTML::Phl::include("$file_include");  ###
   } else {
      open(my $fh, "<$file_name")  or  &HTML::Phl::phl_error("$file_name", '$!');
         while (sysread($fh, my $bate, 8*1024)) {
            $code .= $bate;
         }
      close($fh);
   }
         
   my $decode;
   if ($param =~ /(?:dc|decode)=*([\w\-]*)/) {
      $decode = $1;
   } else {
      $decode = $HTML::Phl::phl{encoding_in};
   }

   $code = &HTML::Phl::phl_decode($decode, $code);
   
   &HTML::Phl::phl_code_perl_eval("$code", "$param", "", "$file_name");
   
   return 1;
}

# Подпрограмма сканирования хэша импорта ключей и параметров из сторонних модулей
sub print_import {
   my $code = $_[0];
   my $number_blok = $_[1];  # Номер блока
   my $key = $_[2];

   $code = <<'[HTML]';
   
   my $n = 1;
   foreach my $key (sort keys (%main::HTML::Phl::)) {
      my $module = $main::HTML::Phl::{$key};
      $module =~ s/\*(.*)::$/$1/;
      print "<B>$n. <U>$module</U></B><br>"  if ($key =~ /::/);
   
      no strict "refs";

      foreach my $m_key (keys (%{"main::HTML::Phl::$key"})) {
         if ($m_key eq "phl_import") {
         
            foreach my $modul_key (sort keys (%{"HTML::Phl::"."$key"."phl_import"})) {
               print "&nbsp; &nbsp; • <B>$modul_key:</B><br>";

               foreach my $code_key (sort keys (%{${"HTML::Phl::"."$key"."phl_import"}{$modul_key}})) {
                  print "&nbsp; &nbsp; &nbsp; &nbsp; - <B><font color=grey>$code_key</font></B><br>";
               }
            }
         }
      }
      $n++  if ($key =~ /::/);
   }
   
[HTML]

   return $code;
}

sub config {
   my $code  = $_[0]; # или file_include
   my $param = $_[1]; # или number_blok
   my $key   = $_[2];
   
   my $config;
   if (!$param) {
      foreach my $key(sort keys(%HTML::Phl::phl)) {
         my $value = $HTML::Phl::phl{$key};
         $config .= "<B>$key</B> = '<font color=gray>".my_encode_entities($value, '<>')."</font>'<br>\n";
      }
   } else {
      $param =~ s/^\s*//;
      $param =~ s/\s*$//;
      my %hash = split(/(?:\s*=>\s*|\s*,\s*)/, $param);
      foreach my $key(keys(%hash)) {
         $config .= "'$key' = '$hash{$key}'<br>\n";
      }
   }
   
   if ($key) {
      # Возвращаем настройки
      $code = "HTML::Phl::Utilit::print_config();\n";
      return $code;
   } else {
      # Печатаем настройки
      HTML::Phl::phl_print "$config";
      return;
   }
}

sub print_config {
   foreach my $key(sort keys(%HTML::Phl::phl)) {
      my $value = $HTML::Phl::phl{$key};
      print "<B>$key</B> = '<font color=gray>".my_encode_entities($value, '<>')."</font>'<br>\n";
   }
   
}

sub my_encode_entities {
   my $line = shift;

   $line =~ s/</&lt;/g;
   $line =~ s/>/&gt;/g;
   
   return $line;
}

sub my_timer {
   my $timer_msg   = $_[0];
   my $timer_file  = $_[1];
     
   utf8::decode("$timer_file");

   my $my_timer = "timer";
   if ($timer_file) {  # $timer_file - метка таймера    
      $my_timer = "timer_$timer_file";
   }

   our %var;

   $var{"$my_timer"} = gettimeofday  if (!$var{"$my_timer"});  # gettimeofday <= use Time::HiRes

   my $name_file;
   $name_file = "<font color=gray>($timer_file)</font>"  if ($timer_file);

   my $timer = '<p><small><font color=gray> • Время - </font><font color=#000099>'.interval($var{"$my_timer"}).
               '</font> ← <font color=#000099>'.$timer_msg.'</font> '.$name_file.'</small></p>';

   $timer = HTML::Phl::encode("$HTML::Phl::phl{encoding_out}", $timer);
   print $timer."\n";

}

sub interval {
   my $time = $_[0] || 0;
   return sprintf ("%.6f", (gettimeofday - $time));
}

# Остановка или запуск таймера
sub key_timer {
   my $code = $_[0];
   my $key  = $_[2];
   
   if ($key =~ /\b(:?tm|timer)\b/) {
      $code = 'eval { $phl{timer} = 4 };'."\n$code";
   } elsif ($key =~ /\b(:?nt|no_timer)\b/) {
      $code = 'eval { $phl{timer} = 0 };'."\n$code";
   } 
   
   return $code;
}

1;
